'ForensiT User Profile Wizard Deployment Kit generated vbscript script 16/02/2010 18:07:57

'******************************************************************************************************************
'This sample script is provided AS IS without warranty of any kind. ForensiT further disclaims all implied
'warranties including, without limitation, any implied warranties of merchantability or of fitness for a
'particular purpose. The entire risk arising out of the use or performance of this sample script remains
'with you. In no event shall ForensiT, its authors, or anyone else involved in the creation, production, or
'delivery of this script be liable for any damages whatsoever (including, without limitation, damages for
'loss of business profits, business interruption, loss of business information, or other pecuniary loss)
'arising out of the use of or inability to use this sample script, even if ForensiT has been advised of the
'possibility of such damages.
'******************************************************************************************************************

'This script will allow you to migrate the profile of the user currently logged onto the workstation
'This script requires Windows Script Host 5.1 and Internet Explorer 4.0 or later
Option Explicit

'Profwiz Parameters
Dim strLogFile

'Script variables
Dim objWshShell, objFSO, objShellApp, objstrMachineFlagPath, AppDataFolder, objFolderItem, objAppDataFolder, objMachineFlag
Dim strNetworkShare, strMachineFlagName, strMachineFlagPath, strError
Dim blnDebug, blnReboot, strComputerName, strCmdLine, intSuccess, intError
Dim strLocalAccount, objNetWork, strDomainSid


'******************************************************************************************************************

'Set variables in this section

'Enter old domain SID (can be partial)
strDomainSid="S-1-5-21-507921405"


'Enter the flag file name
strMachineFlagName="ForensiTMigrated"

'Set blnDebug to true to see debug messages
blnDebug=True

'******************************************************************************************************************


If blnDebug=False Then
	On Error Resume Next
End If

Const ALL_USERS_APPLICATION_DATA = &H23&
Const APPLICATION_DATA = &H1a&
Const ERROR_FILE_NOT_FOUND = &H80070002
Const ERROR_FILE_EXISTS = &H003A
Const HKEY_LOCAL_MACHINE = &H80000002

blnReboot=False

Set objWshShell = WScript.CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")

'Check WSH version
If Not CDbl(WScript.Version)>=5.6 Then
	MsgBox "This script requires Windows Script Host 5.6", vbCritical, "Script Error"
	WScript.Quit
End If

'Get local computer name from registry
strComputerName=objWshShell.RegRead("HKLM\SYSTEM\CurrentControlSet\Control\ComputerName\ActiveComputerName\ComputerName")


'Check if the machine has already been migrated
'This section is dependent on WSH 5.6. If you don't have WSH 5.6 you will need to ammend the following code.
Set objShellApp = CreateObject("Shell.Application")
Set objAppDataFolder = objShellApp.Namespace(APPLICATION_DATA)
Set objFolderItem = objAppDataFolder.Self
strMachineFlagPath=objFolderItem.Path & "\" & strMachineFlagName

If objFSO.FileExists(strMachineFlagPath) Then
	If blnDebug=True Then
		Dim intMsg
		intMsg=MsgBox("The 'migrated' flag file has been set."& vbNewLine & vbNewLine &"Do you want to delete the flag file and continue?", vbQuestion +vbYesNo, "ForensiT Script Debugging")
		If intMsg=vbYes Then
			objFSO.DeleteFile(strMachineFlagPath)
		Else
			WScript.Quit
		End If
	Else
		WScript.Quit
	End If
End If


Dim oReg, strKeyPath, arrSubKeys, subkey, sUserName, pos, sProfilePath  
Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv") 

strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList"
oReg.EnumKey HKEY_LOCAL_MACHINE, strKeyPath, arrSubKeys

For Each subkey In arrSubKeys
	
	If 0<>InStr(subkey, strDomainSid) Then
	
		'Get the profile folder path
		sProfilePath=objWshShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList\" & subkey & "\ProfileImagePath")

		'Get the folder name
		pos=InStrRev(sProfilePath, "\")
		sUserName=Right(sProfilePath, Len(sProfilePath) -pos)
		
		'Check that it does not have a suffix
		pos=InStr(sUserName, ".")
		
		If Not pos=0 Then
			sProfilePath=sUserName
			sUserName=Left(sProfilePath, pos -1)
		End If
		
		strCmdLine="Profwiz.exe /ACCOUNT " & sUserName & " /LOCALACCOUNT " & subkey & " /NOJOIN"
		
		'Special error handling for common failure
		On Error Resume Next
		
		intSuccess=objWshShell.Run (strCmdLine, 0, true)
		
		intError=Err.Number
		
		If blnDebug=True Then
			On Error Goto 0
		End If
		
		If Not intError=0 Then
			If intError=ERROR_FILE_NOT_FOUND Then
				MsgBox "The script cannot find the Profwiz.exe file.", vbCritical, "ForensiT Script Debugging"
				WScript.Quit
			Else
				Err.Raise intError
			End If
		End If
		
	End If
	
Next


'Now join to the domain
strCmdLine="Profwiz.exe /NOMIGRATE /JOIN /NOREBOOT"

blnReboot=True

intSuccess=1

'Special error handling for common failure
On Error Resume Next

'Wscript.Echo strCmdLine
intSuccess=objWshShell.Run (strCmdLine, 0, True)

intError=Err.number

If blnDebug=True Then
	On Error Goto 0
End If

If Not intError=0 Then
	If intError=ERROR_FILE_NOT_FOUND Then
		MsgBox "The script cannot find the Profwiz.exe file.", vbCritical, "ForensiT Script Debugging"
		WScript.Quit
	Else
		Err.Raise intError
	End If
End If

If intSuccess=0 Then
	Set objMachineFlag = objFSO.CreateTextFile(strMachineFlagPath, True)
Else
	blnReboot=False
End If





'******************************************************************************************************************
'Completion message - code in this section can be deleted
Dim strMessage, Icon
strMessage=""

If intSuccess<>0 Then
	Icon=vbExclamation
	
	strMessage=strMessage & "The migration failed. See Log file."
	MsgBox strMessage, Icon, "User Profile Migration Script"
End If


If blnReboot=True Then
	PromptForReboot
End If





'******************************************************************************************************************
'Functions


Function PromptForReboot()
	Dim Result
	Result = MsgBox ("You must restart your computer before the new settings will take effect." _
	& vbNewLine & vbNewLine & "Do you want to restart your computer now?", vbQuestion +vbYesNo, "System Settings Change")
	
	If Result=vbYes Then
		Dim objWMIService, colOperatingSystems, objOperatingSystem
		Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate,(Shutdown)}\\.\root\cimv2")
		Set colOperatingSystems = objWMIService.ExecQuery("Select * from Win32_OperatingSystem")
		
		For Each objOperatingSystem In colOperatingSystems
			objOperatingSystem.Win32Shutdown(6)
		Next
	End If
	
End Function
